### Define Classes Here
setClass("chain.diag",
	representation("energy.rate"="numeric",
		       "energy.steps"="numeric",
		       "swap.rate"="numeric",
		       "swap.steps"="numeric",
		       "cut.rate"="numeric",
		       "cut.steps"="numeric",
		       "burnin"="numeric"))
setClass("sample",
         representation("score"="numeric",
                        "population"="ANY",
                        "temperature"="numeric",
                        "energy"="numeric",
                        "diag"="chain.diag"))
setClass("landscape",
         representation("sample",
                        "partition"="numeric",
                        "rings"="list"))
setClass("order.population",
         representation("list"))
setClass("dag.population",
         representation(dags="list",
                        index="integer",
                        n="numeric",
                        o="numeric"))
                                         

setClass("orderSet",
         representation(orders="vector",
			scores="numeric",
                        counts="integer"))
setClass("objectSet",
         representation(objects="vector",
                        counts="numeric"))
setClass("scoredObjectSet",
         representation("objectSet",
                        "scores"="numeric"))

setAs("orderSet","scoredObjectSet",function(from)
      new("scoredObjectSet",
          objects=lapply(from@orders,as.raw),
          scores=from@scores,counts=from@counts))

setClass("dagSample",
         representation(vertices="integer",
                        dags="vector",
                        p="numeric",
                        n="numeric",
                        o="numeric"))
setClass("fastDagSample",
         representation("dagSample",
                        v="numeric"))
setClass("wrpDagSample",representation(dags="vector",p="numeric",frac="numeric",n="numeric",k="numeric",p1="numeric"))

#setGeneric("landscape",function(sample,partition) standardGeneric("landscape"))
setGeneric("estimate",function(sample,how) standardGeneric("estimate"))

