setClass("eeSampler",
         representation("ladder"="matrix",
                        "energyMin"="numeric",
                        "energyMax"="numeric",
                        "tempMin"="numeric",
                        "tempMax"="numeric",
                        "sample"="landscape",
                        "chain"="numeric"))

setClass("ladder",
         representation("temp.ladder"="numeric",
                        "energy.ladder"="numeric",
                        "temp.range"="numeric",
                        "energy.range"="numeric"))
setGeneric("minEnergy<-",
           function(object,value) standardGeneric("minEnergy<-"))
setReplaceMethod("minEnergy","ladder",function(object,value) {
})



reset.ladders <- function(ladders,newMin) {
  
}

chains.needed <- function(start,end,H,newMin,chain=1,N=5) {
  (log(H-start)-log(2))
}

                                



setClass("energy.ring",representation("energy.range"="numeric",
                                      "scores"      ="numeric",
                                      "population"  ="list"))
setMethod("show","energy.ring",function(object) {
  a = object@energy.range[1]
  b = object@energy.range[2]
  name = if(a < 0 && is.infinite(a)) {
    paste("<",b)
  } else {
    if(is.infinite(b))
      paste(">=",a) else paste("[",a,",",b,")",sep="")
  }
  cat(paste(name," ",length(object@scores)," ",if(length(object@scores)>0) paste(range(object@scores),collapse=","),"\n",collapse=""))
  invisible(object)
})
setMethod("[","energy.ring",function(x,i,j,drop=if(missing(i)) TRUE else length(cols) == 1) {
  new("energy.ring",
      energy.range=x@energy.range,
      scores=x@scores[y],
      population=x@population[y])
})
setMethod("summary","energy.ring",function(object,...) {
  a = object@energy.range[1]
  b = object@energy.range[2]
  name = if(a < 0 && is.infinite(a)) {
    paste("<",b)
  } else {
    if(is.infinite(b))
      paste(">=",a) else paste("[",a,",",b,")",sep="")
  }
  x = length(object@scores)
  names(x) <- name
  list("count"=x,"range"=range(object@scores))
})

setClass("energy.sample",representation("energy.rings"= "list",
                                        "accept.rate" = "numeric",
                                        "exchange.rate"="numeric",
                                        "temperature" = "numeric"))
setMethod("show","energy.sample",function(object) {
  cat(paste("Metropolis Move Acceptance Rate=",object@accept.rate,"\n"))
  cat(paste("Equi-Energy Jump Acceptance Rate=",object@exchange.rate,"\n"))
  sapply(object@energy.rings,show)
  invisible(object)
})
setMethod("summary","energy.sample",function(object,...) {
  sapply(object@energy.rings,summary)
})
setMethod("plot",signature(x="energy.sample",y="missing"),function(x,y,...) {
  scores = sapply(x@energy.rings,slot,"scores");
  plot(unlist(scores),...)
  abline(v=cumsum(sapply(scores,length)))
  abline(h=sapply(x@energy.rings,slot,"energy.range")[2,])
})







## OLD 

energy.rings = function(sample,partition)
  as.factor(.Call("OrderIdentifyRing",as.numeric(sample),as.numeric(parition)))

order.sample.parition = function(x,partition) {
  p = energy.rings(x[[1]],parition)
  y = split(1:length(p),p)
  list(x[[1]],x[[2]],parition,y)
}

energy.sample = function(H0,r,N,b,n,d,m,q=0.1,ar=c(0.2,0.5),beta=2,C=beta,mode="int")
  energy.apply(NULL,H0,r,N,b,n,d,m,q,ar,beta,C,mode)

energy.apply = function(FUN,H0,r,N,b,n,d,m,q=0.1,ar=c(0.2,0.5),beta=2,C=beta,mode="int",...) {
  m    = as.integer(m)
  mode = match(mode,c("int","max","min"))
  b    = as.integer(b)
  n    = as.integer(n)
  ar   = sort(as.numeric(ar))
  q    = as.numeric(q)
  N    = as.integer(N)
  beta = as.numeric(beta)
  H0   = as.numeric(H0)
  r    = as.numeric(r)
  C    = as.numeric(C)
  answer = .Call("BNSL_EquiEnergyOrderApply",d,m,mode,b,n,q,ar,N,H0,r,beta,C,FUN,environment())
  if(length(answer) && length(common.len <- unique(unlist(lapply(answer,length)))) == 1) {
    if(common.len == 1) {
      unlist(answer,recursive=FALSE)
    } else if(common.len > 1)
      array(unlist(answer,recursive=FALSE,dim=c(common.len,b+n)),dimnames=if(!(is.null(n1 <- names(answer[[1]])) && is.null(n2 <- names(answer)))) list(n1,n2))
    else answer
  } else answer
}
