## We should come after the definition of landscape and sample

EquiEnergySample = function(name,
  d,e.range,N,r,t.range=c(1,2*n),...,
  m=3,verbose=TRUE,collapse=FALSE,unique=FALSE,ee.func=fast.order.sample) {
  global.min = Inf
  n          = attrib(d,"vars")
  
  #Estimate energy range if needed
  if(missing(e.range)) {
    if(verbose) cat("Estimating Energy Range from an Initial Run\n")
    omcmc = fast.order.sample(d,m,N,S=0)
    global.min = min(omcmc@score)
    e.range = c(global.min,global.min+2.5*(t.range[2]-t.range[1]))
  }

  if(verbose) {
    cat("\n\nSTARTING EQUI-ENERGY SAMPLING PROCESS\n\n")
    cat("-------------------------------------\n")
    cat("ENERGY RANGE: ")
    cat(paste(prettyNum(e.range),collapse=" .. "))
    cat("\nTEMPERATURE RANGE: ")
    cat(paste(prettyNum(t.range),collapse=" .. "))
    cat("\nRINGS: ")
    cat(paste(prettyNum(r)))
    cat("\n\n")
  }

  ee = NULL
  i  = 1
  
  while(i<=r) {
    if(verbose) {
      cat(paste("CHAIN ",i," OF ",r,"\n",sep=" "))
    }
    #Generate Ladders
    eL = energy.ladder(e.range[1],e.range[2])
    tL = temperature.ladder(t.range[1],t.range[2])
    sL = .25*(1/r)^(1/tL)

    s    = r-(i-1)
    ee.n = ee.func(d,m,s*N,H=eL[s],T=tL[s],S=sL[s],X=ee)
    if(collapse && !is.null(ee)) {
      ee.n@population = c(ee.n@population,ee@population)
      ee.n@score      = c(ee.n@score,ee@score)
    }
    ee.n = landscape(ee.n,eL[2:length(eL)],H=if(s>1) eL[s-1] else -Inf)
    i = i + 1
    #Perform post-sampling checks
  }
}
  
