order.dist <- function(a,b) .Call("BNSL_SwapSearch",as.integer(a),as.integer(b))
order.hamm <- function(a,b) .Call("BNSL_OrderDist",as.integer(a),as.integer(b))
order.overlap <- function(a,b,w=10) .Call("BNSL_OrderOverlap",a,b,as.integer(w))

order.sis <- function(db,o,m,temp=1)
  .Call("BNSL_SISOMethod",db,as.integer(o),as.integer(m),as.numeric(temp),DUP=FALSE)
order.features <- function(db,order,m)
  .Call("BNSL_score_features",db,as.integer(order-1),as.integer(m),DUP=FALSE)
ESS <- function(o) {
  W <- LogSumExp(o$weight)
  w <- exp(o$weight)
  length(w)/(1+(var(w)*(length(w)/exp(W))^2))
}

### M-H functions
order.metropolis <- function(db,order,max.parents,iter,use.max=FALSE)
  .Call("BNSL_Metropolis",db,as.integer(order),as.integer(max.parents),
        as.integer(iter),as.logical(use.max),DUP=FALSE)

order.start.chain <- function(db,vars,max.parents,iter,use.max=FALSE,
                              order=sample(order)) {
  function(...) {
    x <- order.metropolis(db,order,max.parents,iter,use.max)
    order <<- x[[3]]
    x
  }
}

### SIS Functions
order.extension <- function(db,order,ext,m,use.max=FALSE)
  .Call("BNSL_CalculateExtension",
        db,as.integer(order),
        as.integer(ext),as.integer(m),as.logical(use.max),
        DUP=FALSE)
order.score <- function(db,order,m,use.max=FALSE)
  .Call("BNSL_ScoreOrdering",
        db,as.integer(order),as.integer(m),as.logical(use.max),DUP=FALSE)

#Partial ordering
order.from.graph <- function(g,n=1) .Call("BNSL_TopologicalSort",edges(g),nodes(g),as.integer(n))

