#include "common.h"
#include <Rdefines.h>
#include <db.h>
#include "scoring.h"
#include "bitstring.h"

void InvToPerm(int *inv,int *perm,int *co,int N) {
  char *vmax;
  int   m,i;
  /*  for(i=0;i<N;i++)
    Rprintf("%d ",inv[i]);
    Rprintf(" (");*/

  for(i=N-1;i>=0;i--) {
    co[i]=(N-1)-inv[i];
    for(m=i+1;m<N;m++)
      if(co[m]<=co[i]) co[m]--;
  }

  /*  for(i=0;i<N;i++)
    Rprintf("%d ",co[i]);
    Rprintf(") [");*/

  for(i=0;i<N;i++) 
    perm[(N-1)-co[i]] = i+1;

  /*  for(i=0;i<N;i++)
    Rprintf("%d ",perm[i]);
    Rprintf("]\n");*/
}

void PermToInv(int*perm,int*inv,int N) {
  int i,m;
  for(i=1;i<=N;i++) {
    inv[i-1] = 0;
    for(m=0;perm[m]!=i;m++)
      if(perm[m] > i) inv[i-1]++;
  }
}

void operator_CX(score_ctx ctx,int*A,int*B,int*C,int*D) {
  char*vmax = vmaxget();
  int* map0 = (int*)R_alloc(sizeof(int),ctx->n);
  int* map1 = (int*)R_alloc(sizeof(int),ctx->n);
  int i,current,init=unif_int(ctx->n);
  for(i=0;i<ctx->n;i++) {
    map0[A[i]-1] = i+1;
    map1[B[i]-1] = i+1;
  }
/*   for(i=0;i<ctx->n;i++) Rprintf("%d ",A[i]); */
/*   Rprintf("\n"); */
/*   for(i=0;i<ctx->n;i++) Rprintf("%d ",B[i]); */
/*   Rprintf("\n\n"); */
  
/*   for(i=0;i<ctx->n;i++) */
/*     Rprintf("%d ",map0[i]); */
/*   Rprintf("\n"); */
/*   for(i=0;i<ctx->n;i++) */
/*     Rprintf("%d ",map1[i]); */
/*   Rprintf("\n"); */
  current = init;
  
  do {
    int  other = B[current];
    C[current] = A[current];
    current = map0[other-1]-1;
    map0[other-1]=0;
  } while(current != init);
  do {
    int other  = A[current];
    D[current] = B[current];
    current = map1[other-1]-1;
    map1[other-1]=0;
  } while(current != init);
  
  for(i=0;i<ctx->n;i++) {
    int o;
    o = B[i];
    if(map0[o-1]) C[i] = o;
    o = A[i];
    if(map1[o-1]) D[i] = o;
  }
/*   for(i=0;i<ctx->n;i++) Rprintf("%d ",C[i]); */
/*   Rprintf("\n"); */
/*   for(i=0;i<ctx->n;i++) Rprintf("%d ",D[i]); */

  vmaxset(vmax);
}

void operator_ISX(score_ctx ctx,int*A,int*B,int*C,int*D) {
  char *vmax = vmaxget();
  /* Temporary storage */
  int  *invA = (int*)R_alloc(sizeof(int),5*ctx->n);
  int  *invB = invA + ctx->n;
  int  *invC = invB + ctx->n;
  int  *invD = invC + ctx->n;
  int  *co   = invD + ctx->n;
  int   a;
  
  PermToInv(A,invA,ctx->n);PermToInv(B,invB,ctx->n);

  /* The actual Crossver */
  a = unif_int(ctx->n);
  memcpy(invC,invA,sizeof(int)*ctx->n);
  memcpy(invD,invC,sizeof(int)*ctx->n);
  memcpy(invC+a,invB+a,sizeof(int)*(ctx->n-a));
  memcpy(invD+a,invA+a,sizeof(int)*(ctx->n-a));

  InvToPerm(invC,C,co,ctx->n);InvToPerm(invD,D,co,ctx->n);
  vmaxset(vmax);

}

void operator_ISXU(score_ctx ctx,int*A,int*B,int*C,int*D) {
  char *vmax = vmaxget();
  /* Temporary storage */
  int  *invA = (int*)R_alloc(sizeof(int),5*ctx->n);
  int  *invB = invA + ctx->n;
  int  *invC = invB + ctx->n;
  int  *invD = invC + ctx->n;
  int  *co   = invD + ctx->n;
  int   a;
  
  PermToInv(A,invA,ctx->n);PermToInv(B,invB,ctx->n);

  /* The actual Crossver */
  for(a=0;a<ctx->n;a++) {
    if(unif_rand() < 0.5) {
      invC[a] = invA[a];invD[a] = invB[a];
    } else {
      invC[a] = invB[a];invD[a] = invA[a];
    }
  }

  InvToPerm(invC,C,co,ctx->n);InvToPerm(invD,D,co,ctx->n);
  vmaxset(vmax);

}

void operator_ISXA(score_ctx ctx,int*A,int*B,int*C,int*D) {
  char *vmax = vmaxget();
  /* Temporary storage */
  int  *invA = (int*)R_alloc(sizeof(int),5*ctx->n);
  int  *invB = invA + ctx->n;
  int  *invC = invB + ctx->n;
  int  *invD = invC + ctx->n;
  int  *co   = invD + ctx->n;
  int   a;
  
  PermToInv(A,invA,ctx->n);PermToInv(B,invB,ctx->n);

  /* The actual Crossver */
  for(a=0;a<ctx->n;a++) {
    if(invA[a] == invB[a]) {
      invC[a] = (unif_rand() < 0.1) ? (ctx->n-(a+1))-invA[a] : invA[a];
      invD[a] = (unif_rand() < 0.1) ? (ctx->n-(a+1))-invA[a] : invA[a];
    } else {
      invC[a] = (unif_rand() < 0.5) ? invA[a] : invB[a];
      invD[a] = (unif_rand() < 0.5) ? invB[a] : invA[a];
    }
  }

  InvToPerm(invC,C,co,ctx->n);InvToPerm(invD,D,co,ctx->n);
  vmaxset(vmax);

}
