#include <Rinternals.h>
#include <Rdefines.h>

SEXP OrderIdentifyRing(SEXP scores,SEXP part) {
  int i,j,r=length(part);
  SEXP ring;
  PROTECT(ring = allocVector(INTSXP,length(scores)));
  for(i=0;i<length(scores);i++) {
    for(j=0;j<r;j++)
      if(REAL(scores)[i] < REAL(part)[j]) break;
    INTEGER(ring)[i] = j+1;
  }
  setAttrib(ring,install("partition"),duplicate(part));
  UNPROTECT(1);
  return ring;
}

void ee_ChainDiagnostics(SEXP ret,int accept_jump,int reject_jump,
			 int *accept_swap,int *reject_swap,int n,
			 int burnin) {
  SEXP   res,sr,ss;
  int    i;
  double sj   = (double)accept_jump + (double)reject_jump;
  double aj   = (sj==0)?0.0:((double)accept_jump)/sj;
  
  PROTECT(res = NEW_OBJECT(MAKE_CLASS("chain.diag")));

  PROTECT(sr  = allocVector(REALSXP,n));
  PROTECT(ss  = allocVector(REALSXP,n));
  for(i=0;i<n;i++) {
    REAL(ss)[i] = accept_swap[i]+reject_swap[i];
    REAL(sr)[i] = REAL(ss)[i]>0.0?((double)accept_swap[i])/REAL(ss)[i]:0.0;
  }
  SET_SLOT(res,install("swap.rate"),sr);
  SET_SLOT(res,install("swap.steps"),ss);
  SET_SLOT(res,install("energy.rate"),ScalarReal(aj));
  SET_SLOT(res,install("energy.steps"),ScalarReal(sj));
  SET_SLOT(res,install("cut.rate"),ScalarReal(0.0));
  SET_SLOT(res,install("cut.steps"),ScalarReal(0.0));
  SET_SLOT(res,install("burnin"),ScalarReal((double)burnin));
  SET_SLOT(ret,install("diag"),res);
  UNPROTECT(3);
}

