#include <Rinternals.h>
#include "common.h"
#include "graphutil.h"
#include <db.h>

SEXP TAB_TabAndDraw(SEXP D,SEXP B,SEXP V,SEXP W) {
  char *vmax = vmaxget();
  DB   *db;
  int    n   = length(B);
  int    v   = INTEGER(V)[0]-1;
  int    nl  = nlevels(VECTOR_ELT(D,v));
  char *pp   = (char*)R_alloc(sizeof(char),n);
  int  *tmp  = (int*)R_alloc(sizeof(int),nl);

  GetRNGstate();
  db_create(&db,NULL,0);
  db->open(db,NULL,NULL,NULL,DB_HASH,DB_CREATE,0);

  /* Tabulate existing dataset */
  int i,j,unique = 0;
  DBT key,data;
  memset(&key,0,sizeof(DBT));
  memset(&data,0,sizeof(DBT));
  key.size = sizeof(char)*n;
  data.size= sizeof(int)*nl;
  for(i=0;i<length(VECTOR_ELT(D,0));i++) {
    for(j=0;j<n;j++) pp[j] = INTEGER(VECTOR_ELT(D,INTEGER(B)[j]-1))[i];
    key.data = pp;
    if(db->get(db,NULL,&key,&data,0) == 0) {
      int *c = (int*)data.data;
      c[v]++;
    } else {
      memset(tmp,1,sizeof(int)*nl);
      data.data = tmp;
      tmp[v]++;
      unique++;
    }
    db->put(db,NULL,&key,&data,0);
  }
  Rprintf("%d unique values of %d\n",unique,length(VECTOR_ELT(D,0)));


  /* Draw new observations */

  SEXP draw;
  PROTECT(draw = allocVector(INTSXP,length(W)));
  for(i=0;i<length(W);i++) {
    int w = INTEGER(W)[i]-1;
    for(j=0;j<n;j++) pp[j] = INTEGER(VECTOR_ELT(D,INTEGER(B)[j]-1))[w];
    key.data = pp;
    if(db->get(db,NULL,&key,&data,0) == 0) {
      double Z = 0;
      double cdf,u = unif_rand();
      int   *c = (int*)data.data;
      for(j=0;j<nl;j++) Z += (double)c[j];
      for(j=0;j<nl-1;j++) {
	cdf += ((double)c[j])/Z;
	if(u < cdf) break;
      }
      INTEGER(draw)[i] = j+1;
    } else
      error("Woah. Nothing for this tuple? Not possible");
  }
  db->close(db,0);
  vmaxset(vmax);
  PutRNGstate();
  UNPROTECT(1);
  return draw;
}


