#ifndef _h_fastdb_
#define _h_fastdb_

#include "priors.h"

double bnsl_fast_score_order(DB*d,int*,int,int);

typedef struct fast_score_ctx {
  DB     *d;
  DBC    *cur;
  DBT     key,data;
  int    *inv;
  int    *o;
  double  gamma,beta;

  double *b_vec;
  double *k_mat;
  double *score;
  int     n,K;
} *fast_score_ctx;

typedef struct parent_sets {
  DB *db;
  DBT key,data;
  char   *node;
  char   *pset;
} *parent_sets;


fast_score_ctx fast_ctx(SEXP D,int K);
double fast_ctx_score(fast_score_ctx,int*,int);
void   fast_ctx_beta(fast_score_ctx,double b);
parent_sets fast_ctx_sets(fast_score_ctx);

#endif
