#include "common.h"
#include <db.h>
#include "scoring.h"
#include "dag.h"

extern double logsumexp(double*,int);



/* SEXP BNSL_K2Sequential(SEXP d,SEXP order,SEXP max_p) { */
/*   int i,j,k,m; */
/*   double *score,*pdf; */
/*   int    *elt,*uses; */
/*   char   *pa; */
/*   SEXP    res,names,g,klass; */
/*   char    tmp[256]; */

/*   GetRNGstate(); */
/*   BEGIN_DATABASE_ACCESS(d); */
/*   pa = (char*)R_alloc(sizeof(char),KEY_SIZE*N); */
/*   memset(pa,0,sizeof(char)*KEY_SIZE*N); */
/*   elt = (int*)R_alloc(sizeof(int),N+1); */
/*   memset(pa,0,sizeof(int)*(N+1)); */
/*   pdf = (double*)R_alloc(sizeof(double),N+1); */
/*   uses = (int*)R_alloc(sizeof(int),N); */
/*   memset(uses,0,sizeof(int)*N); */
  

/*   for(i=0;i<n;i++) { */
/*     int    z,parent; */
/*     int    node_i = INTEGER(order)[i]-1; */

/*     pa[KEY_SIZE*node_i] = node_i+1;     */
/*     parent = 0; */
/*     do { */
/*       double norm,ru,cdf; */

/*       SET_KEY_VALUE(&pa[KEY_SIZE*node_i]); */
/*       DATABASE_LOOKUP; */

/*       elt[0] = 0; */
/*       pdf[0] = GET_SCORE_VALUE; */
/*       k=1; */
      
/*       for(j=0;j<i;j++) { */
/* 	if(bit_test(((char*)key.data+1),INTEGER(order)[j]-1)) continue; */
/* 	elt[k] = INTEGER(order)[j]; */
/* 	bit_set(((char*)key.data+1),elt[k]-1); */
/* 	DATABASE_LOOKUP; */
/* 	bit_clear(((char*)key.data+1),elt[k]-1); */
/* 	pdf[k++] = GET_SCORE_VALUE; */
/*       } */

/*       revsort(pdf,elt,k); */
/*       norm = logsumexp(pdf,k); */
      
/*       ru = unif_rand(); */
/*       cdf= 0.0;z=0; */
/*       for(j=0;j<k;j++) { */
/* 	cdf += exp(pdf[j]-norm); */
/* 	if(ru < cdf) break; */
/*       } */
/*       z = elt[j]; */
/*       if(z > 0) { */
/* 	bit_set(&pa[(KEY_SIZE*node_i)+1],z-1); */
/* 	uses[z-1]++; */
/* 	parent++; */
/*       } */
      
/*     } while(z > 0 && parent < INTEGER(max_p)[0]); */
    
/*   } */
/*   PROTECT(res = allocVector(VECSXP,length(order))); */
/*   PROTECT(names = allocVector(STRSXP,length(order))); */
/*   for(i=0;i<length(order);i++) { */
/*     int r=0; */
/*     if(uses[i] > 0) { */
/*       SEXP tmp = edge_list(uses[i]); */
/*       SEXP foo = VECTOR_ELT(tmp,0); */
/*       for(j=0;j<length(order);j++) { */
/* 	if(bit_test(&pa[(KEY_SIZE*j)+1],i)) INTEGER(foo)[r++] = j+1; */
/*       } */
/*       SET_VECTOR_ELT(res,i,tmp); */
/*     } */
/*     sprintf(tmp,"%d",i+1); */
/*     SET_STRING_ELT(names,i,mkChar(tmp)); */
/*   } */
/*   END_DATABASE_ACCESS; */
/*   setAttrib(res,R_NamesSymbol,names); */
/*   klass = MAKE_CLASS("graphNEL"); */
/*   PROTECT(g = NEW_OBJECT(klass)); */
/*   SET_SLOT(g,install("edgeL"),res); */
/*   SET_SLOT(g,install("nodes"),duplicate(names)); */
/*   SET_SLOT(g,install("edgemode"),ScalarString(mkChar("directed"))); */
/*   UNPROTECT(3);   */
/*   PutRNGstate(); */
/*   return g; */
/* } */

/*
SEXP BNSL_K2Search(SEXP d,SEXP max_parents,SEXP order) {
  int i,j,k,max_k;
  double best;
  
  pset_ctx ctx = bnsl_pset_ctx(d,INTEGER(max_parents)[0]);
  for(i=0;i<length(order);i++) {
    max_k=(i<ctx->k)?i:ctx->k;
    bnsl_pset_set_vertex(ctx,INTEGER(order)[i]);
    for(k=0;k<max_k;k++) {
      best = R_NegInf;
    }
  }
}
*/

SEXP BNSL_K2Search(SEXP D,SEXP order,SEXP K) {
  dag_ctx ctx = bnsl_dag_ctx(D,INTEGER(K)[0]);
  int     i,j;
  for(i=1;i<length(order);i++) {
    double score;
    int to = INTEGER(order)[i];
    bnsl_dag_update_score(ctx,to);
    score = bnsl_dag_get_score(ctx,to);
    while(bnsl_dag_degree(ctx,to) < INTEGER(K)[0]) {
      int next=0;
      for(j=0;j<i;j++) {
	int    from  = INTEGER(order)[j];
	if(!bnsl_dag_has_edge(ctx,from,to)) {
	  bnsl_dag_set_edge(ctx,from,to,1);
	  bnsl_dag_update_score(ctx,to);
	  if(bnsl_dag_get_score(ctx,to) > score) {
	    score = bnsl_dag_get_score(ctx,to);
	    next = 1;
	  } else
	    bnsl_dag_set_edge(ctx,from,to,0);
	}
      }
      if(!next) break;
    }
  }
  bnsl_dag_ctx_done(ctx);
  return dag_to_graph(ctx,"graphNEL");
}


/* SEXP BNSL_K2Search(SEXP d,SEXP order,SEXP max_p) { */
/*   int     i,j,k,r,changes; */
/*   char*   pa; */
/*   double* score; */
/*   int*    parents,*uses; */
/*   SEXP    res,names,g,klass; */
/*   char    tmp[256]; */

/*   BEGIN_DATABASE_ACCESS(d); */
/*   pa = (char*)R_alloc(sizeof(char),KEY_SIZE*N); */
/*   memset(pa,0,sizeof(char)*KEY_SIZE*N); */

/*   score = (double*)R_alloc(sizeof(double),N); */
/*   for(i=0;i<n;i++) { */
/*     pa[KEY_SIZE*i] = i+1; */
/*     SET_KEY_VALUE(&pa[KEY_SIZE*i]); */
/*     DATABASE_LOOKUP; */
/*     score[i] = GET_SCORE_VALUE; */
/*   } */
  
/*   parents = (int*)R_alloc(sizeof(int),N); */
/*   memset(parents,0,sizeof(int)*N); */
/*   uses    = (int*)R_alloc(sizeof(int),N); */
/*   memset(uses,0,sizeof(int)*N); */

/*   for(i=1;i<n;i++) { */
/*     int node_i   = INTEGER(order)[i]-1;	/\* PA index *\/ */
/*     double p_old = score[node_i]; */
/*     SET_KEY_VALUE(&pa[KEY_SIZE*node_i]); */
/*     while(parents[node_i] < INTEGER(max_p)[0]) { */
/*       int        z = -1; */
/*       double p_new = p_old; */
/*       for(j=0;j<i;j++) { */
/* 	double current_p; */
/* 	int    current_z = INTEGER(order)[j]-1; */
/* 	if(i == j) continue; */
/* 	if(bit_test(&pa[(KEY_SIZE*node_i)+1],current_z)) continue; */

/* 	bit_set(&pa[(KEY_SIZE*node_i)+1],current_z); */
/* 	DATABASE_LOOKUP; */
/* 	current_p = GET_SCORE_VALUE; */
/* 	bit_clear(&pa[(KEY_SIZE*node_i)+1],current_z); */

/* 	if(p_new < current_p) { */
/* 	  p_new = current_p; */
/* 	  z     = current_z; */
/* 	} */
/*       } */
/*       if(p_new > p_old) { */
/* 	p_old = p_new; */
/* 	uses[z]++; */
/* 	parents[node_i]++; */
/* 	bit_set(&pa[(KEY_SIZE*node_i)+1],z);	 */
/* 	/\*	for(k=0;k<n;k++) */
/* 		if(bit_test(&pa[(KEY_SIZE*node_i)+1],k)) printf("%d ",k+1);*\/ */
/*       } else break; */
/*     } */
/*     /\*    printf("]\n");*\/ */
/*   } */

/*   PROTECT(res = allocVector(VECSXP,length(order))); */
/*   PROTECT(names = allocVector(STRSXP,length(order))); */
/*   for(i=0;i<length(order);i++) { */
/*     int r=0; */
/*     if(uses[i] > 0) { */
/*       SEXP tmp = edge_list(uses[i]); */
/*       SEXP foo = VECTOR_ELT(tmp,0); */
/*       for(j=0;j<length(order);j++) { */
/* 	if(bit_test(&pa[(KEY_SIZE*j)+1],i)) INTEGER(foo)[r++] = j+1; */
/*       } */
/*       SET_VECTOR_ELT(res,i,tmp); */
/*     } */
/*     sprintf(tmp,"%d",i+1); */
/*     SET_STRING_ELT(names,i,mkChar(tmp)); */
/*   } */
/*   END_DATABASE_ACCESS; */
/*   setAttrib(res,R_NamesSymbol,names); */
/*   klass = MAKE_CLASS("graphNEL"); */
/*   PROTECT(g = NEW_OBJECT(klass)); */
/*   SET_SLOT(g,install("edgeL"),res); */
/*   SET_SLOT(g,install("nodes"),duplicate(names)); */
/*   SET_SLOT(g,install("edgemode"),ScalarString(mkChar("directed"))); */
/*   UNPROTECT(3); */
/*   return g; */
/* } */
