#include <fenv.h>
#include "score_search.h"

extern double logsumexp(double*,int);

#define log1p_add(X,Y) X = (X > (Y)) ? X + log1p(exp((Y)-X)) : Y + log1p(exp(X-(Y)));

double update_scores(DB*db,DBT*key,DBT*data,
		     int *order,int o_n,int candidate,
		     int extension,int max_parents,
		     double score,int*P,int n) {
  int r,p,x,y,z;
  int m_p = (o_n > max_parents-1) ? max_parents-1 : o_n;
  char*pa = key->data+1;
  memset(key->data,0,key->size);
  ((char*)key->data)[0] = extension;
  bit_set(pa,candidate-1);
  DATABASE_LOOKUP_REF;
  feclearexcept(FE_ALL_EXCEPT);
  log1p_add(score,GET_SCORE_VALUE_REF);

  
  for(p=m_p;p>=1;p--) {
    inittwiddle(p,o_n,P);
    DATABASE_LOOKUP_REF;
    log1p_add(score,GET_SCORE_VALUE_REF);
    while(!twiddle(&x,&y,&z,P)) {
      bit_set(pa,order[x]-1);
      bit_clear(pa,order[y]-1);
      DATABASE_LOOKUP_REF;
      log1p_add(score,GET_SCORE_VALUE_REF);
    }
  }
  bit_clear(pa,candidate-1);
  if(fetestexcept(FE_UNDERFLOW)) 
    error("floating point underflow while updateing score values");
  return score;
}

int sample_element(double*pdf,int*indices,int n) {
  double ru     = unif_rand();
  double cdf,no = logsumexp(pdf,n);
  int    i      = -1;
  for(i=0;i<n;i++) pdf[i] -= no;
  revsort(pdf,indices,n);

  for(i=0;i<n;i++) {
    cdf += exp(pdf[i]);
    if(ru < cdf) break;
  }
  return i;
}

SEXP BNSL_FastSISO(SEXP _d,SEXP vars,SEXP M) {
  int     i;
  double* scores;
  SEXP    order;
  
  BEGIN_DATABASE_ACCESS(_d);
  PROTECT(order = allocVector(INTSXP,length(vars)));

  
  UNPROTECT(1);
  END_DATABASE_ACCESS;
  return R_NilValue;
}
